NX Open C++ Reference Guide
Public Member Functions | List of all members
NXOpen::Display::DynamicSectionBuilder Class Reference

Represents a Dynamic Section Builder used for creating sections. More...

Inheritance diagram for NXOpen::Display::DynamicSectionBuilder:
NXOpen::Builder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder NXOpen::Annotations::LightweightSectionBuilder

Public Member Functions

void AlternatePlane ()
 Cycle through planes that are 90 degrees aligned to the current section plane. More...
 
bool BoxExtentDelayUpdate ()
 Returns the delay box extent update. More...
 
double BoxExtentMargin ()
 Returns the margin for box section extents
Use Display::DynamicSectionBuilder::BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes. More...
 
NXOpen::SelectINXObjectListBoxExtentObjects ()
 Returns the objects that define the extents for box section. More...
 
bool BoxExtentSupported ()
 Returns the box extent support. More...
 
NXOpen::NXColorCapColor ()
 Returns the cap color. More...
 
NXOpen::Display::DynamicSectionTypes::CapColorOption CapColorOption ()
 Returns the cap color option
Created in NX5.0.0. More...
 
NXOpen::Display::DynamicSectionTypes::Clip ClipType ()
 Returns the clip type
Created in NX5.0.0. More...
 
NXOpen::DatumPlaneCreateDatumPlane ()
 Creates a datum plane from the active section plane. More...
 
NXOpen::Display::DynamicSectionTypes::CoordinateSystem CsysType ()
 Returns the coordinate system used for creating section plane along X, Y or Z principal planes. More...
 
NXOpen::NXColorCurveColor ()
 Returns the curve color. More...
 
NXOpen::Display::DynamicSectionTypes::CurveColorOption CurveColorOption ()
 Returns the curve color option
Created in NX5.0.0. More...
 
bool DeferCurveUpdate ()
 Returns the defer curve update property. More...
 
void EditView (NXOpen::ModelingView *view)
 Edits the section object in the modeling view. More...
 
void GetActivePlane (NXOpen::Display::DynamicSectionTypes::Axis *planeAxis, NXOpen::Display::DynamicSectionTypes::ActivePlane *activePlane)
 Gets the active plane in the section. More...
 
NXOpen::Display::PlaneGridBuilderGetGridSettings ()
 Creates a grid settings builder from the active section plane. More...
 
NXString GetName ()
 Gets the section name. More...
 
NXOpen::Vector3d GetNormal ()
 Gets the normal of the section plane. More...
 
double GetOffset ()
 Gets the the plane offset. More...
 
void GetOffsetLimits (double *minimumOffset, double *maximumOffset)
 Gets minimum and maximum offset limits. More...
 
NXOpen::Point3d GetOrigin ()
 Gets the section origin. More...
 
double GetPlaneThickness ()
 Gets the thickness between active plane pair. More...
 
double GetRotationAngle (NXOpen::Display::DynamicSectionTypes::Axis rotationAxis)
 Gets rotation angle for specified axis. More...
 
NXOpen::Matrix3x3 GetRotationMatrix ()
 Gets the section rotation matrix. More...
 
NXOpen::NXColorInterferenceColor ()
 Returns the interference color. More...
 
bool IsAssociativitySupported ()
 Determines if an associative section plane is supported. More...
 
NXOpen::Display::LayerSettingsBuilderLayerSettings ()
 Returns the layer settings builder. More...
 
bool LoadAllIntersecting (NXOpen::PartLoadStatus **loadStatus)
 Loads all components that intersect the current section plane. More...
 
bool LoadNearIntersecting (NXOpen::PartLoadStatus **loadStatus)
 Loads components that intersect the current section plane and are near the section plane origin. More...
 
bool LockPlanes ()
 Returns the lock planes flag. More...
 
int NumberInSeries ()
 Returns the number of requested section planes in the current section series. More...
 
void OffsetOriginInPlane (double xOffset, double yOffset)
 Offsets section origin within current section plane. More...
 
void PlaneX ()
 Creates a plane along X direction. More...
 
void PlaneY ()
 Creates a plane along Y direction. More...
 
void PlaneZ ()
 Creates a plane along Z direction. More...
 
void RestoreView ()
 Restores the section to the saved section in the view database. More...
 
void ReverseDirection ()
 Reverses the plane direction. More...
 
bool ReverseSeries ()
 Returns the reverse series flag
Created in NX6.0.0. More...
 
void SaveCurves (const NXString &groupName)
 Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name. More...
 
void SaveCurves (const char *groupName)
 Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name. More...
 
double SeriesSpacing ()
 Returns the section plane spacing in the current section series. More...
 
void SetActivePlane (NXOpen::Display::DynamicSectionTypes::Axis planeAxis, NXOpen::Display::DynamicSectionTypes::ActivePlane activePlane)
 Sets the active plane in the section. More...
 
void SetAssociativePlane (NXOpen::Plane *planeTag)
 Makes dynamic section associative to the specified plane The plane must be a smart plane; otherwise an error will be reported. More...
 
void SetBoxExtentDelayUpdate (bool delayUpdate)
 Sets the delay box extent update. More...
 
void SetBoxExtentMargin (double margin)
 Sets the margin for box section extents
Use Display::DynamicSectionBuilder::BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes. More...
 
void SetCapColor (NXOpen::NXColor *capColor)
 Sets the cap color. More...
 
void SetCapColorOption (NXOpen::Display::DynamicSectionTypes::CapColorOption capColorOption)
 Sets the cap color option
Created in NX5.0.0. More...
 
void SetClipType (NXOpen::Display::DynamicSectionTypes::Clip clipType)
 Sets the clip type
Created in NX5.0.0. More...
 
void SetCsysType (NXOpen::Display::DynamicSectionTypes::CoordinateSystem csys)
 Sets the coordinate system used for creating section plane along X, Y or Z principal planes. More...
 
void SetCurveColor (NXOpen::NXColor *curveColor)
 Sets the curve color. More...
 
void SetCurveColorOption (NXOpen::Display::DynamicSectionTypes::CurveColorOption curveColorOption)
 Sets the curve color option
Created in NX5.0.0. More...
 
void SetDefaultPlane ()
 Set current section plane to its default definition. More...
 
void SetDefaults ()
 Set current section to the default values. More...
 
void SetDeferCurveUpdate (bool deferCurveUpdate)
 Sets the defer curve update property. More...
 
void SetInterferenceColor (NXOpen::NXColor *interferenceColor)
 Sets the interference color. More...
 
void SetLockPlanes (bool lockPlanes)
 Sets the lock planes flag. More...
 
bool SetName (const NXString &sectionName)
 Sets the section name. More...
 
bool SetName (const char *sectionName)
 Sets the section name. More...
 
void SetNormal (const NXOpen::Vector3d &normal)
 Sets the normal of the section plane
Section offset and rotation matrix are updated. More...
 
void SetNumberInSeries (int numberSectionsRequested)
 Sets the number of requested section planes in the current section series. More...
 
void SetOffset (double offset)
 Sets the the plane offset. More...
 
void SetOffsetByPoint (const NXOpen::Point3d &point)
 This method offsets the active clipping plane such that the plane passes through the specified point. More...
 
void SetOrigin (const NXOpen::Point3d &origin)
 Sets the section origin. More...
 
void SetPlane (const NXOpen::Point3d &axisOrigin, const NXOpen::Point3d &origin, const NXOpen::Matrix3x3 &rotationMatrix)
 Sets a section plane to be the specified plane The plane is created at the specified origin with the specified rotation matrix. More...
 
void SetPlaneThickness (double planeThickness)
 Sets the thickness between active plane pair. More...
 
void SetReverseSeries (bool reverseSeries)
 Sets the reverse series flag
Created in NX6.0.0. More...
 
void SetRotationAngle (NXOpen::Display::DynamicSectionTypes::Axis rotationAxis, double angle)
 Rotates the section about specified axis by the specified angle. More...
 
void SetRotationMatrix (NXOpen::Display::DynamicSectionTypes::Axis rotationAxis, const NXOpen::Matrix3x3 &rotationMatrix)
 Sets the section rotation matrix
Specify Display::DynamicSectionTypes::AxisNone if the axis about which rotation was performed is not known. More...
 
void SetSeriesSpacing (double sectionSpacing)
 Sets the section plane spacing in the current section series. More...
 
void SetShowCap (bool showCap)
 Sets the cap on off flag
Created in NX5.0.0. More...
 
void SetShowClip (bool showClip)
 Sets the clip on off flag
Created in NX5.0.0. More...
 
void SetShowCurves (bool showCurves)
 Sets the curve on off flag. More...
 
void SetShowGrid (bool showGrid)
 Sets the show grid display flag
Created in NX6.0.0. More...
 
void SetShowInterference (bool showInterference)
 Sets the interference on off flag. More...
 
void SetShowViewer (bool showViewer)
 Sets the 2D viewer display flag
Created in NX6.0.0. More...
 
void SetType (NXOpen::Display::DynamicSectionTypes::Type type)
 Sets the section type
Created in NX5.0.0. More...
 
void SetView (NXOpen::ModelingView *view)
 Sets the modeling view in which section object edits are being done. More...
 
bool ShowCap ()
 Returns the cap on off flag
Created in NX5.0.0. More...
 
bool ShowClip ()
 Returns the clip on off flag
Created in NX5.0.0. More...
 
void ShowCurvePreview (bool showCurvePreview)
 Show/hide curve preview. More...
 
bool ShowCurves ()
 Returns the curve on off flag. More...
 
bool ShowGrid ()
 Returns the show grid display flag
Created in NX6.0.0. More...
 
bool ShowInterference ()
 Returns the interference on off flag. More...
 
void ShowSectionCurves (bool showCurves)
 Shows the section curves in the view associated with the builder. More...
 
bool ShowViewer ()
 Returns the 2D viewer display flag
Created in NX6.0.0. More...
 
NXOpen::Display::DynamicSectionTypes::Type Type ()
 Returns the section type
Created in NX5.0.0. More...
 
void UpdateBoxExtents ()
 Update box section display by recomputing the box extents if necessary. More...
 
NXOpen::ModelingViewView ()
 Returns the modeling view in which section object edits are being done. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Represents a Dynamic Section Builder used for creating sections.


The dynamic sectioning is performed on a displayable part that is displayed in the modeling work view.It is possible to specify the view after creating the builder. However, the specified view must be modeling work view. This operation is meant to be performed in an interactive mode with visual feedback.


Builder Creation:


The dynamic section builder can be used to create new dynamic section objects OR to edit an existing section object.

See Display::DynamicSectionCollection::CreateSectionBuilder

When a view is specified during the builder creation, the dynamic section object will be activated in the view. When the dynamic section object is activated in the view, view clipping and capping is enabled. However, it is not necessary to specify the view.


There are three different types of sections that are currently being supported.




User can switch between these types at any time.


Assembly and Modeling Operations




All the APIs accept geometric data such as plane origin, plane normal in the absolute coordinate system.


Saving changes


Builder::Commit method will activate the section object in the modeling view. It returns the dynamic section object tag.


Section Plane Families:


An important issue with dynamic sectioning is the ability to easily define a group of related cross-section planes. A group of related cross-section planes will be known as a Plane Family. An important idea in understanding a plane family is the concept of a defining or a Base Plane. The base plane of the plane family is the starting point (i.e. plane) for the plane family. All planes in the family are related by an offset to the base plane. There are two types of plane families:




Linear Plane Family


A linear plane family is defined by an infinite group of parallel planes. All of the planes in a linear family are parallel to its base plane (i.e. along the base plane normal at some linear offset value). This is illustrated below with a base plane and three parallel planes to it that are members of the plane family.


Base Plane

| | | |
| | | |
| | | | ==\> Nomal to all planes.
| | | |
| | | |


Axi-Symmetric Plane Family


An axi-symmetric plane family is defined by rotating the base plane about one of the three primary axes. There are an infinite number of planes in an axi-symmetric plane family similar to a linear plane family. This is illustrated below with a base plane and three planes rotated about the z-axis.

\ | /
\ | /
\ | /
\|/____ Base Plane


Switching between plane families


Methods defining a new linear family




Following methods define a new axi-symmetric family




Transition between plane families


When a method defining a new linear family is invoked, then if



The same thing happens when a method defining a new axi-symmetric plane is invoked.


Examples:


1. Linear Family


Goal: User wants to create a series of sections along X axis.


API sequence:

planeX - Create a plane with base plane at X = 0
See Display.DynamicSectionBuilder.PlaneX
SetOffset( 50 ) - Plane at X = 50
SetOffset( 100 ) - Plane at X = 100
SetOffset( 0 ) - Plane at X = 0


2. Axi-symmetric Family


Goal: User wants to create a series of sections by planes rotated around X axis of the section plane.


API sequence:

SetRotation( X, 45 ) - The current plane becomes base plane. Then
the plane rotated around X axis by 45
degrees.
SetRotation( X, 90 ) - Plane rotated around X axis by 90 degrees.
SetRotation( X, 90 ) - Plane rotated around X axis by 0 degrees.
Back to original position.


To create a new instance of this class, use NXOpen::Display::DynamicSectionCollection::CreateSectionBuilder
Default values.

Property Value

BoxExtentDelayUpdate

false

CapColorOption

Any

ClipType

Section

CurveColorOption

Any

LayerSettings.LayerOption

Work

LockPlanes

true

ShowCap

true

ShowClip

true

ShowCurves (deprecated)

false

ShowGrid

false

ShowInterference

false

ShowViewer

false

Type

OnePlane


Created in NX5.0.0.

Member Function Documentation

void NXOpen::Display::DynamicSectionBuilder::AlternatePlane ( )

Cycle through planes that are 90 degrees aligned to the current section plane.

For example, for a XY plane with normal along positive Z axis, invoking this method will cycle through the planes in the following order.

- YZ plane with normal along X axis
- XZ plane with normal along Y axis
- XY plane with normal along Z axis

The section offset and rotation matrix are updated.


Created in NX5.0.0.

License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::BoxExtentDelayUpdate ( )

Returns the delay box extent update.

This determines if the box section extent updates are delayed when selection list is modified (see Display::DynamicSectionBuilder::BoxExtentObjects ).
If true then use Display::DynamicSectionBuilder::UpdateBoxExtents to update the box section. If false then update happens immediately.

Use Display::DynamicSectionBuilder::BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes.


Created in NX10.0.0.

License requirements : None

double NXOpen::Display::DynamicSectionBuilder::BoxExtentMargin ( )

Returns the margin for box section extents
Use Display::DynamicSectionBuilder::BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes.



Created in NX10.0.0.

License requirements : None

NXOpen::SelectINXObjectList* NXOpen::Display::DynamicSectionBuilder::BoxExtentObjects ( )

Returns the objects that define the extents for box section.

Absence of the object list indicates that the extent construction is not supported.


Created in NX10.0.0.

License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::BoxExtentSupported ( )

Returns the box extent support.

This is used to determine if the box extent construction is supported. Any box extent related APIs will not function when the extent construction is not supported.


Created in NX10.0.0.

License requirements : None

NXOpen::NXColor* NXOpen::Display::DynamicSectionBuilder::CapColor ( )

Returns the cap color.

Used when cap color type is Display::DynamicSectionTypes::CapColorOptionAny


Created in NX5.0.0.

License requirements : None

NXOpen::Display::DynamicSectionTypes::CapColorOption NXOpen::Display::DynamicSectionBuilder::CapColorOption ( )

Returns the cap color option
Created in NX5.0.0.



License requirements : None

NXOpen::Display::DynamicSectionTypes::Clip NXOpen::Display::DynamicSectionBuilder::ClipType ( )

Returns the clip type
Created in NX5.0.0.



License requirements : None

NXOpen::DatumPlane* NXOpen::Display::DynamicSectionBuilder::CreateDatumPlane ( )

Creates a datum plane from the active section plane.

Returns
Datum plane
Created in NX5.0.0.

License requirements : None
NXOpen::Display::DynamicSectionTypes::CoordinateSystem NXOpen::Display::DynamicSectionBuilder::CsysType ( )

Returns the coordinate system used for creating section plane along X, Y or Z principal planes.


Created in NX5.0.0.

License requirements : None

NXOpen::NXColor* NXOpen::Display::DynamicSectionBuilder::CurveColor ( )

Returns the curve color.

Used when the curve color option is set to Display::DynamicSectionTypes::CurveColorOptionAny .


Created in NX5.0.0.

License requirements : None

NXOpen::Display::DynamicSectionTypes::CurveColorOption NXOpen::Display::DynamicSectionBuilder::CurveColorOption ( )

Returns the curve color option
Created in NX5.0.0.



License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::DeferCurveUpdate ( )

Returns the defer curve update property.

This property can be used to reduce number of curve updates when performing a series of attribute changes on the dynamic section. After the changes are done, undefer the curve update. Undeferring will update the curves, if and only if, curve update is required based on the applied changes.


Created in NX8.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::EditView ( NXOpen::ModelingView view)

Edits the section object in the modeling view.


The view being edited must be the modeling view. This is provided to handle scenarios when the working view is changed when sectioning is in progress. It is the responsibility of user to save pending changes using Builder::Commit method. Otherwise, any existing changes will be lost.


Created in NX6.0.0.

License requirements : None

Parameters
viewModeling view
void NXOpen::Display::DynamicSectionBuilder::GetActivePlane ( NXOpen::Display::DynamicSectionTypes::Axis planeAxis,
NXOpen::Display::DynamicSectionTypes::ActivePlane activePlane 
)

Gets the active plane in the section.


See Display::DynamicSectionBuilder::SetActivePlane for details.


Created in NX5.0.0.

License requirements : None

Parameters
planeAxisplaneaxis
activePlaneactiveplane
NXOpen::Display::PlaneGridBuilder* NXOpen::Display::DynamicSectionBuilder::GetGridSettings ( )

Creates a grid settings builder from the active section plane.

Returns

Created in NX6.0.0.

License requirements : None
NXString NXOpen::Display::DynamicSectionBuilder::GetName ( )

Gets the section name.

Caller is expected to free the memory.

Returns

Created in NX6.0.0.

License requirements : None
NXOpen::Vector3d NXOpen::Display::DynamicSectionBuilder::GetNormal ( )

Gets the normal of the section plane.

Returns
Section plane normal
Created in NX5.0.0.

License requirements : None
double NXOpen::Display::DynamicSectionBuilder::GetOffset ( )

Gets the the plane offset.

Returns

Created in NX5.0.0.

License requirements : None
void NXOpen::Display::DynamicSectionBuilder::GetOffsetLimits ( double *  minimumOffset,
double *  maximumOffset 
)

Gets minimum and maximum offset limits.


Offset limits are dependent on the active section plane. They are determined based on the model bounding box and location of the active section plane.

Display::DynamicSectionBuilder::SetOffset can specify offset outside the offset limits. In that case the offset limits are extended to include the specified offset.


Created in NX5.0.0.

License requirements : None

Parameters
minimumOffsetMinimum offset
maximumOffsetMinimum offset
NXOpen::Point3d NXOpen::Display::DynamicSectionBuilder::GetOrigin ( )

Gets the section origin.

Returns
Section origin
Created in NX5.0.0.

License requirements : None
double NXOpen::Display::DynamicSectionBuilder::GetPlaneThickness ( )

Gets the thickness between active plane pair.

This is valid when the section contains more than one clipping plane. When the section planes are locked, setting thickness will not alter the current thickness.

Returns

Created in NX5.0.0.

License requirements : None
double NXOpen::Display::DynamicSectionBuilder::GetRotationAngle ( NXOpen::Display::DynamicSectionTypes::Axis  rotationAxis)

Gets rotation angle for specified axis.

Returns
Rotation angle in degrees
Created in NX5.0.0.

License requirements : None
Parameters
rotationAxisrotationaxis
NXOpen::Matrix3x3 NXOpen::Display::DynamicSectionBuilder::GetRotationMatrix ( )

Gets the section rotation matrix.

Returns
Rotation matrix
Created in NX5.0.0.

License requirements : None
NXOpen::NXColor* NXOpen::Display::DynamicSectionBuilder::InterferenceColor ( )

Returns the interference color.


Created in NX5.0.0.

License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::IsAssociativitySupported ( )

Determines if an associative section plane is supported.

Returns

Created in NX9.0.0.

License requirements : None
NXOpen::Display::LayerSettingsBuilder* NXOpen::Display::DynamicSectionBuilder::LayerSettings ( )

Returns the layer settings builder.


Created in NX9.0.0.

License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::LoadAllIntersecting ( NXOpen::PartLoadStatus **  loadStatus)

Loads all components that intersect the current section plane.

Errors are reported by the part load status. Caller is expected to destroy the memory used by load status object.

Returns
New component loaded flag
Created in NX5.0.0.

License requirements : adv_assemblies ("ADVANCED ASSEMBLIES")
Parameters
loadStatusErrors occurred during loading of parts.
bool NXOpen::Display::DynamicSectionBuilder::LoadNearIntersecting ( NXOpen::PartLoadStatus **  loadStatus)

Loads components that intersect the current section plane and are near the section plane origin.

The distance used for which components are "near" the section plane origin is determined internally. Errors are reported by the part load status. Caller is expected to destroy the memory used by load status object.

Returns
New component loaded flag
Created in NX5.0.0.

License requirements : adv_assemblies ("ADVANCED ASSEMBLIES")
Parameters
loadStatusErrors occurred during loading of parts.
bool NXOpen::Display::DynamicSectionBuilder::LockPlanes ( )

Returns the lock planes flag.

The planes can be locked in case of Two Parallel Planes and Box Section. When locked the planes will move together.


Created in NX5.0.0.

License requirements : None

int NXOpen::Display::DynamicSectionBuilder::NumberInSeries ( )

Returns the number of requested section planes in the current section series.


Created in NX6.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::OffsetOriginInPlane ( double  xOffset,
double  yOffset 
)

Offsets section origin within current section plane.


The section is moved to new location along in the section plane. The offsets are w.r.t. current origin along the X and Y axis of the section plane respectively.


Created in NX5.0.0.

License requirements : None

Parameters
xOffsetDelta X from the current position
yOffsetDelta Y from the current position
void NXOpen::Display::DynamicSectionBuilder::PlaneX ( )

Creates a plane along X direction.


The plane is created with the base plane at the origin with normal along X axis of the coordinate system Display::DynamicSectionBuilder::CsysType and Display::DynamicSectionBuilder::SetCsysType .

The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box.

Section offset and rotation matrix are updated.

Section thickness is recomputed based on the bounding box.


Created in NX5.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::PlaneY ( )

Creates a plane along Y direction.


The plane is created with the base plane at the origin with normal along Y axis of the coordinate system Display::DynamicSectionBuilder::CsysType and Display::DynamicSectionBuilder::SetCsysType .

The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box.

Section offset and rotation matrix are updated.

Section thickness is recomputed based on the bounding box.


Created in NX5.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::PlaneZ ( )

Creates a plane along Z direction.


The plane is created with the base plane at the origin with normal along Z axis of the coordinate system Display::DynamicSectionBuilder::CsysType and Display::DynamicSectionBuilder::SetCsysType .

The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box.

Section offset and rotation matrix are updated.

Section thickness is recomputed based on the bounding box.


Created in NX5.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::RestoreView ( )

Restores the section to the saved section in the view database.


Created in NX5.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::ReverseDirection ( )

Reverses the plane direction.

This will flip the side of the model being clipped.
Section rotation matrix is updated.


Created in NX5.0.0.

License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::ReverseSeries ( )

Returns the reverse series flag
Created in NX6.0.0.



License requirements : None

void NXOpen::Display::DynamicSectionBuilder::SaveCurves ( const NXString groupName)

Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name.

The group is displayed in the part navigator. If the customer default "Load Solids/Sheets when Saving Section Curves" is enabled, then this will load exact solid/sheet bodies for the visible lightweight bodies intersecting the clipping planes. This may increase the time and memory used by the operation, but will ensure exact section curves.


Created in NX5.0.0.

License requirements : None

Parameters
groupNameName of the group containing curves
NOTE: The full Unicode character set is not supported for this parameter.
void NXOpen::Display::DynamicSectionBuilder::SaveCurves ( const char *  groupName)

Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name.

The group is displayed in the part navigator. If the customer default "Load Solids/Sheets when Saving Section Curves" is enabled, then this will load exact solid/sheet bodies for the visible lightweight bodies intersecting the clipping planes. This may increase the time and memory used by the operation, but will ensure exact section curves.


Created in NX5.0.0.

License requirements : None

Parameters
groupNameName of the group containing curves
NOTE: The full Unicode character set is not supported for this parameter.
double NXOpen::Display::DynamicSectionBuilder::SeriesSpacing ( )

Returns the section plane spacing in the current section series.


Created in NX6.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::SetActivePlane ( NXOpen::Display::DynamicSectionTypes::Axis  planeAxis,
NXOpen::Display::DynamicSectionTypes::ActivePlane  activePlane 
)

Sets the active plane in the section.


Single Plane:

There is no secondary plane. Only primary plane exists.


Two Parallel Plane Section:

Display::DynamicSectionTypes::AxisZ is the active axis and primary/secondary plane can be activated.

Box Section:

The active plane pair can be selected by specifying the planeAxis Given an axis, the primary/secondary planes can be activated.

E.g. To activate primary plane along the local X axis use Display::DynamicSectionTypes::AxisX and Display::DynamicSectionTypes::ActivePlanePrimary .


Created in NX5.0.0.

License requirements : None

Parameters
planeAxisplaneaxis
activePlaneactiveplane
void NXOpen::Display::DynamicSectionBuilder::SetAssociativePlane ( NXOpen::Plane planeTag)

Makes dynamic section associative to the specified plane The plane must be a smart plane; otherwise an error will be reported.


Associative plane can be specified only if the builder supports associativity (see Display::DynamicSectionBuilder::IsAssociativitySupported ).


Created in NX9.0.0.

License requirements : None

Parameters
planeTagPlane
void NXOpen::Display::DynamicSectionBuilder::SetBoxExtentDelayUpdate ( bool  delayUpdate)

Sets the delay box extent update.

This determines if the box section extent updates are delayed when selection list is modified (see Display::DynamicSectionBuilder::BoxExtentObjects ).
If true then use Display::DynamicSectionBuilder::UpdateBoxExtents to update the box section. If false then update happens immediately.

Use Display::DynamicSectionBuilder::BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes.


Created in NX10.0.0.

License requirements : None

Parameters
delayUpdatedelayupdate
void NXOpen::Display::DynamicSectionBuilder::SetBoxExtentMargin ( double  margin)

Sets the margin for box section extents
Use Display::DynamicSectionBuilder::BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes.



Created in NX10.0.0.

License requirements : None

Parameters
marginmargin
void NXOpen::Display::DynamicSectionBuilder::SetCapColor ( NXOpen::NXColor capColor)

Sets the cap color.

Used when cap color type is Display::DynamicSectionTypes::CapColorOptionAny


Created in NX5.0.0.

License requirements : None

Parameters
capColorcapcolor
void NXOpen::Display::DynamicSectionBuilder::SetCapColorOption ( NXOpen::Display::DynamicSectionTypes::CapColorOption  capColorOption)

Sets the cap color option
Created in NX5.0.0.



License requirements : None

Parameters
capColorOptioncapcoloroption
void NXOpen::Display::DynamicSectionBuilder::SetClipType ( NXOpen::Display::DynamicSectionTypes::Clip  clipType)

Sets the clip type
Created in NX5.0.0.



License requirements : None

Parameters
clipTypecliptype
void NXOpen::Display::DynamicSectionBuilder::SetCsysType ( NXOpen::Display::DynamicSectionTypes::CoordinateSystem  csys)

Sets the coordinate system used for creating section plane along X, Y or Z principal planes.


Created in NX5.0.0.

License requirements : None

Parameters
csyscsys
void NXOpen::Display::DynamicSectionBuilder::SetCurveColor ( NXOpen::NXColor curveColor)

Sets the curve color.

Used when the curve color option is set to Display::DynamicSectionTypes::CurveColorOptionAny .


Created in NX5.0.0.

License requirements : None

Parameters
curveColorcurvecolor
void NXOpen::Display::DynamicSectionBuilder::SetCurveColorOption ( NXOpen::Display::DynamicSectionTypes::CurveColorOption  curveColorOption)

Sets the curve color option
Created in NX5.0.0.



License requirements : None

Parameters
curveColorOptioncurvecoloroption
void NXOpen::Display::DynamicSectionBuilder::SetDefaultPlane ( )

Set current section plane to its default definition.

This will only modify section plane geometry.


Created in NX5.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::SetDefaults ( )

Set current section to the default values.

This will modify all section geometry as well as section attributes.


Created in NX5.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::SetDeferCurveUpdate ( bool  deferCurveUpdate)

Sets the defer curve update property.

This property can be used to reduce number of curve updates when performing a series of attribute changes on the dynamic section. After the changes are done, undefer the curve update. Undeferring will update the curves, if and only if, curve update is required based on the applied changes.


Created in NX8.0.0.

License requirements : None

Parameters
deferCurveUpdatedefercurveupdate
void NXOpen::Display::DynamicSectionBuilder::SetInterferenceColor ( NXOpen::NXColor interferenceColor)

Sets the interference color.


Created in NX5.0.0.

License requirements : None

Parameters
interferenceColorinterferencecolor
void NXOpen::Display::DynamicSectionBuilder::SetLockPlanes ( bool  lockPlanes)

Sets the lock planes flag.

The planes can be locked in case of Two Parallel Planes and Box Section. When locked the planes will move together.


Created in NX5.0.0.

License requirements : None

Parameters
lockPlaneslockplanes
bool NXOpen::Display::DynamicSectionBuilder::SetName ( const NXString sectionName)

Sets the section name.


The specified name will be validated. A section is expected to have a unique name in a part. The name may be modified to make it unique within the part.

Returns
If specified name was modified to ensure uniqueness
Created in NX6.0.0.

License requirements : None
Parameters
sectionNameSection name
bool NXOpen::Display::DynamicSectionBuilder::SetName ( const char *  sectionName)

Sets the section name.


The specified name will be validated. A section is expected to have a unique name in a part. The name may be modified to make it unique within the part.

Returns
If specified name was modified to ensure uniqueness
Created in NX6.0.0.

License requirements : None
Parameters
sectionNameSection name
void NXOpen::Display::DynamicSectionBuilder::SetNormal ( const NXOpen::Vector3d normal)

Sets the normal of the section plane
Section offset and rotation matrix are updated.



Created in NX5.0.0.

License requirements : None

Parameters
normalSection plane normal
void NXOpen::Display::DynamicSectionBuilder::SetNumberInSeries ( int  numberSectionsRequested)

Sets the number of requested section planes in the current section series.


Created in NX6.0.0.

License requirements : None

Parameters
numberSectionsRequestedNumber of section requested (>= 1).
void NXOpen::Display::DynamicSectionBuilder::SetOffset ( double  offset)

Sets the the plane offset.

When there are more than one clipping planes in the section, the active clipping plane will be not be allowed to cross-over the non-active clipping plane.
If Display::DynamicSectionBuilder::LockPlanes and Display::DynamicSectionBuilder::SetLockPlanes is off, section thickness is updated.


Created in NX5.0.0.

License requirements : None

Parameters
offsetOffset
void NXOpen::Display::DynamicSectionBuilder::SetOffsetByPoint ( const NXOpen::Point3d point)

This method offsets the active clipping plane such that the plane passes through the specified point.

When there are more than one clipping planes in the section, the active clipping plane will be not be allowed to cross-over the non-active clipping plane.
See Display::DynamicSectionBuilder::SetOffset


Created in NX5.0.0.

License requirements : None

Parameters
pointPoint in absolute coordinate system.
void NXOpen::Display::DynamicSectionBuilder::SetOrigin ( const NXOpen::Point3d origin)

Sets the section origin.


The section is moved to new location. It obeys the lock flag Display::DynamicSectionBuilder::LockPlanes and Display::DynamicSectionBuilder::SetLockPlanes . if it is a multiple plane section.
Section offset is updated.


Created in NX5.0.0.

License requirements : None

Parameters
originSection origin
void NXOpen::Display::DynamicSectionBuilder::SetPlane ( const NXOpen::Point3d axisOrigin,
const NXOpen::Point3d origin,
const NXOpen::Matrix3x3 rotationMatrix 
)

Sets a section plane to be the specified plane The plane is created at the specified origin with the specified rotation matrix.

The axis origin can be same as the plane origin. To defind a linear plane family from the absolute origin, define axis origin as {0, 0, 0}. The section offset will reflect the distance of the plane from the axis origin.
Section offset and rotation matrix are updated.


Created in NX5.0.0.

License requirements : None

Parameters
axisOriginAxis origin
originPlane origin.
rotationMatrixRotation matrix
void NXOpen::Display::DynamicSectionBuilder::SetPlaneThickness ( double  planeThickness)

Sets the thickness between active plane pair.

This property is only available when the section contains more than one clipping plane. When the section planes are locked, setting thickness will not alter the current thickness.


Created in NX5.0.0.

License requirements : None

Parameters
planeThicknessActive plane thickness
void NXOpen::Display::DynamicSectionBuilder::SetReverseSeries ( bool  reverseSeries)

Sets the reverse series flag
Created in NX6.0.0.



License requirements : None

Parameters
reverseSeriesreverseseries
void NXOpen::Display::DynamicSectionBuilder::SetRotationAngle ( NXOpen::Display::DynamicSectionTypes::Axis  rotationAxis,
double  angle 
)

Rotates the section about specified axis by the specified angle.

If a rotation already exists about the specified axis, then the section is rotated such that the total rotation angle is set to the specified angle. Rotation about only one axis is active at a time.

1. Create plane with normal along Z.
2. Display.DynamicSectionBuilder.SetRotationAngle( X, 30 )
Rotates plane around X axis by 30 degrees
3. Display.DynamicSectionBuilder.SetRotationAngle( X, 45 )
Incremental rotation of 45 - 30 = 15 degrees.


Section offset and rotation matrix are updated.


Created in NX5.0.0.

License requirements : None

Parameters
rotationAxisrotationaxis
angleRotation angle in degrees
void NXOpen::Display::DynamicSectionBuilder::SetRotationMatrix ( NXOpen::Display::DynamicSectionTypes::Axis  rotationAxis,
const NXOpen::Matrix3x3 rotationMatrix 
)

Sets the section rotation matrix
Specify Display::DynamicSectionTypes::AxisNone if the axis about which rotation was performed is not known.



Section offset and rotation matrix are updated.


Created in NX5.0.0.

License requirements : None

Parameters
rotationAxisrotationaxis
rotationMatrixRotation matrix
void NXOpen::Display::DynamicSectionBuilder::SetSeriesSpacing ( double  sectionSpacing)

Sets the section plane spacing in the current section series.


Created in NX6.0.0.

License requirements : None

Parameters
sectionSpacingDistance between sections (>= 0.02).
void NXOpen::Display::DynamicSectionBuilder::SetShowCap ( bool  showCap)

Sets the cap on off flag
Created in NX5.0.0.



License requirements : None

Parameters
showCapshowcap
void NXOpen::Display::DynamicSectionBuilder::SetShowClip ( bool  showClip)

Sets the clip on off flag
Created in NX5.0.0.



License requirements : None

Parameters
showClipshowclip
void NXOpen::Display::DynamicSectionBuilder::SetShowCurves ( bool  showCurves)

Sets the curve on off flag.


When the dynamic section object is visible in the view, the curves from the section object are shown in that view.


Deprecated:
Deprecated in NX6.0.0. Use ModelingView::SetDynamicSectionVisible instead.


Created in NX5.0.0.

License requirements : None

Parameters
showCurvesshowcurves
void NXOpen::Display::DynamicSectionBuilder::SetShowGrid ( bool  showGrid)

Sets the show grid display flag
Created in NX6.0.0.



License requirements : None

Parameters
showGridshowgrid
void NXOpen::Display::DynamicSectionBuilder::SetShowInterference ( bool  showInterference)

Sets the interference on off flag.


Created in NX5.0.0.

License requirements : None

Parameters
showInterferenceshowinterference
void NXOpen::Display::DynamicSectionBuilder::SetShowViewer ( bool  showViewer)

Sets the 2D viewer display flag
Created in NX6.0.0.



License requirements : None

Parameters
showViewershowviewer
void NXOpen::Display::DynamicSectionBuilder::SetType ( NXOpen::Display::DynamicSectionTypes::Type  type)

Sets the section type
Created in NX5.0.0.



License requirements : None

Parameters
typetype
void NXOpen::Display::DynamicSectionBuilder::SetView ( NXOpen::ModelingView view)

Sets the modeling view in which section object edits are being done.


Display::DynamicSectionBuilder::SetView method is present for legacy reasons.

Use Display::DynamicSectionBuilder::EditView instead.


Created in NX5.0.0.

License requirements : None

Parameters
viewModeling view
bool NXOpen::Display::DynamicSectionBuilder::ShowCap ( )

Returns the cap on off flag
Created in NX5.0.0.



License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::ShowClip ( )

Returns the clip on off flag
Created in NX5.0.0.



License requirements : None

void NXOpen::Display::DynamicSectionBuilder::ShowCurvePreview ( bool  showCurvePreview)

Show/hide curve preview.


When editing a view section, curve preview can be shown while the editing is in progress. The preview is removed once the changes are committed on the builder or when the builder is destroyed.

Hiding preview will remove the section series preview too.


Created in NX10.0.0.

License requirements : None

Parameters
showCurvePreviewshowcurvepreview
bool NXOpen::Display::DynamicSectionBuilder::ShowCurves ( )

Returns the curve on off flag.


When the dynamic section object is visible in the view, the curves from the section object are shown in that view.


Deprecated:
Deprecated in NX6.0.0. Use ModelingView::IsDynamicSectionVisible instead.


Created in NX5.0.0.

License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::ShowGrid ( )

Returns the show grid display flag
Created in NX6.0.0.



License requirements : None

bool NXOpen::Display::DynamicSectionBuilder::ShowInterference ( )

Returns the interference on off flag.


Created in NX5.0.0.

License requirements : None

void NXOpen::Display::DynamicSectionBuilder::ShowSectionCurves ( bool  showCurves)

Shows the section curves in the view associated with the builder.

If no view is associated with the builder, then the curves are Shown in the current work view.


Created in NX7.5.0.

License requirements : None

Parameters
showCurvesshowcurves
bool NXOpen::Display::DynamicSectionBuilder::ShowViewer ( )

Returns the 2D viewer display flag
Created in NX6.0.0.



License requirements : None

NXOpen::Display::DynamicSectionTypes::Type NXOpen::Display::DynamicSectionBuilder::Type ( )

Returns the section type
Created in NX5.0.0.



License requirements : None

void NXOpen::Display::DynamicSectionBuilder::UpdateBoxExtents ( )

Update box section display by recomputing the box extents if necessary.


Use Display::DynamicSectionBuilder::BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes.


Created in NX10.0.0.

License requirements : None

NXOpen::ModelingView* NXOpen::Display::DynamicSectionBuilder::View ( )

Returns the modeling view in which section object edits are being done.


Display::DynamicSectionBuilder::SetView method is present for legacy reasons.

Use Display::DynamicSectionBuilder::EditView instead.


Created in NX5.0.0.

License requirements : None


The documentation for this class was generated from the following file:
Copyright 2012 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.